Index: branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/MemPRContext.cs
===================================================================
--- branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/MemPRContext.cs	(revision 14420)
+++ branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/MemPRContext.cs	(revision 14420)
@@ -0,0 +1,347 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.SolutionModel;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Algorithms.MemPR {
+  [Item("MemPRContext", "Abstract base class for MemPR contexts.")]
+  [StorableClass]
+  public abstract class MemPRContext<TSolution, TContext, TSolutionContext> : ParameterizedNamedItem,
+      ISingleObjectivePopulationContext<TSolution>, ISolutionModelContext<TSolution>, IStochasticContext,
+      IMaximizationContext, IEvaluatedSolutionsContext
+      where TSolution : class, IItem
+      where TContext : MemPRContext<TSolution, TContext, TSolutionContext>
+      where TSolutionContext : SingleSolutionMemPRContext<TSolution, TContext, TSolutionContext> {
+
+    private IExecutionContext parent;
+    public IExecutionContext Parent {
+      get { return parent; }
+      set { parent = value; }
+    }
+
+    [Storable]
+    private IScope scope;
+    public IScope Scope {
+      get { return scope; }
+      private set { scope = value; }
+    }
+
+    IKeyedItemCollection<string, IParameter> IExecutionContext.Parameters {
+      get { return Parameters; }
+    }
+
+    [Storable]
+    private IValueParameter<BoolValue> maximization;
+    public bool Maximization {
+      get { return maximization.Value.Value; }
+      set { maximization.Value.Value = value; }
+    }
+
+    [Storable]
+    private IValueParameter<BoolValue> initialized;
+    public bool Initialized {
+      get { return initialized.Value.Value; }
+      set { initialized.Value.Value = value; }
+    }
+
+    [Storable]
+    private IValueParameter<IntValue> iterations;
+    public int Iterations {
+      get { return iterations.Value.Value; }
+      set { iterations.Value.Value = value; }
+    }
+
+    [Storable]
+    private IValueParameter<IntValue> evaluatedSolutions;
+    public int EvaluatedSolutions {
+      get { return evaluatedSolutions.Value.Value; }
+      set { evaluatedSolutions.Value.Value = value; }
+    }
+
+    [Storable]
+    private IValueParameter<DoubleValue> bestQuality;
+    public double BestQuality {
+      get { return bestQuality.Value.Value; }
+      set { bestQuality.Value.Value = value; }
+    }
+
+    [Storable]
+    private IValueParameter<IntValue> hcSteps;
+    public int HcSteps {
+      get { return hcSteps.Value.Value; }
+      set { hcSteps.Value.Value = value; }
+    }
+
+    [Storable]
+    private IValueParameter<IntValue> byBreeding;
+    public int ByBreeding {
+      get { return byBreeding.Value.Value; }
+      set { byBreeding.Value.Value = value; }
+    }
+
+    [Storable]
+    private IValueParameter<IntValue> byRelinking;
+    public int ByRelinking {
+      get { return byRelinking.Value.Value; }
+      set { byRelinking.Value.Value = value; }
+    }
+
+    [Storable]
+    private IValueParameter<IntValue> bySampling;
+    public int BySampling {
+      get { return bySampling.Value.Value; }
+      set { bySampling.Value.Value = value; }
+    }
+
+    [Storable]
+    private IValueParameter<IntValue> byHillclimbing;
+    public int ByHillclimbing {
+      get { return byHillclimbing.Value.Value; }
+      set { byHillclimbing.Value.Value = value; }
+    }
+
+    [Storable]
+    private IValueParameter<IntValue> byTabuwalking;
+    public int ByTabuwalking {
+      get { return byTabuwalking.Value.Value; }
+      set { byTabuwalking.Value.Value = value; }
+    }
+
+    [Storable]
+    private IValueParameter<IRandom> random;
+    public IRandom Random {
+      get { return random.Value; }
+      set { random.Value = value; }
+    }
+
+    IEnumerable<IScope> IPopulationContext.Population {
+      get { return scope.SubScopes; }
+    }
+    
+    public IEnumerable<ISingleObjectiveSolutionScope<TSolution>> Population {
+      get { return scope.SubScopes.OfType<ISingleObjectiveSolutionScope<TSolution>>(); }
+    }
+    public void AddToPopulation(ISingleObjectiveSolutionScope<TSolution> solScope) {
+      scope.SubScopes.Add(solScope);
+    }
+    public void ReplaceAtPopulation(int index, ISingleObjectiveSolutionScope<TSolution> solScope) {
+      scope.SubScopes[index] = solScope;
+    }
+    public ISingleObjectiveSolutionScope<TSolution> AtPopulation(int index) {
+      return scope.SubScopes[index] as ISingleObjectiveSolutionScope<TSolution>;
+    }
+    public int PopulationCount {
+      get { return scope.SubScopes.Count; }
+    }
+
+    [Storable]
+    private List<Tuple<double, double, double>> breedingStat;
+    public List<Tuple<double, double, double>> BreedingStat {
+      get { return breedingStat; }
+    }
+    [Storable]
+    private List<Tuple<double, double>> hillclimbingStat;
+    public List<Tuple<double, double>> HillclimbingStat {
+      get { return hillclimbingStat; }
+    }
+    [Storable]
+    private List<Tuple<double, double>> tabuwalkingStat;
+    public List<Tuple<double, double>> TabuwalkingStat {
+      get { return tabuwalkingStat; }
+    }
+
+    [Storable]
+    public ISolutionModel<TSolution> Model { get; set; }
+
+    [StorableConstructor]
+    protected MemPRContext(bool deserializing) : base(deserializing) { }
+    protected MemPRContext(MemPRContext<TSolution, TContext, TSolutionContext> original, Cloner cloner)
+      : base(original, cloner) {
+      scope = cloner.Clone(original.scope);
+      maximization = cloner.Clone(original.maximization);
+      initialized = cloner.Clone(original.initialized);
+      iterations = cloner.Clone(original.iterations);
+      evaluatedSolutions = cloner.Clone(original.evaluatedSolutions);
+      bestQuality = cloner.Clone(original.bestQuality);
+      hcSteps = cloner.Clone(original.hcSteps);
+      byBreeding = cloner.Clone(original.byBreeding);
+      byRelinking = cloner.Clone(original.byRelinking);
+      bySampling = cloner.Clone(original.bySampling);
+      byHillclimbing = cloner.Clone(original.byHillclimbing);
+      byTabuwalking = cloner.Clone(original.byTabuwalking);
+      random = cloner.Clone(original.random);
+      breedingStat = original.breedingStat.Select(x => Tuple.Create(x.Item1, x.Item2, x.Item3)).ToList();
+      hillclimbingStat = original.hillclimbingStat.Select(x => Tuple.Create(x.Item1, x.Item2)).ToList();
+      tabuwalkingStat = original.tabuwalkingStat.Select(x => Tuple.Create(x.Item1, x.Item2)).ToList();
+
+      Model = cloner.Clone(original.Model);
+    }
+    public MemPRContext() : this("MemPRContext") { }
+    public MemPRContext(string name) : base(name) {
+      scope = new Scope("Global");
+
+      Parameters.Add(maximization = new ValueParameter<BoolValue>("Maximization", new BoolValue(false)));
+      Parameters.Add(initialized = new ValueParameter<BoolValue>("Initialized", new BoolValue(false)));
+      Parameters.Add(iterations = new ValueParameter<IntValue>("Iterations", new IntValue(0)));
+      Parameters.Add(evaluatedSolutions = new ValueParameter<IntValue>("EvaluatedSolutions", new IntValue(0)));
+      Parameters.Add(bestQuality = new ValueParameter<DoubleValue>("BestQuality", new DoubleValue(double.NaN)));
+      Parameters.Add(hcSteps = new ValueParameter<IntValue>("HcSteps", new IntValue(0)));
+      Parameters.Add(byBreeding = new ValueParameter<IntValue>("ByBreeding", new IntValue(0)));
+      Parameters.Add(byRelinking = new ValueParameter<IntValue>("ByRelinking", new IntValue(0)));
+      Parameters.Add(bySampling = new ValueParameter<IntValue>("BySampling", new IntValue(0)));
+      Parameters.Add(byHillclimbing = new ValueParameter<IntValue>("ByHillclimbing", new IntValue(0)));
+      Parameters.Add(byTabuwalking = new ValueParameter<IntValue>("ByTabuwalking", new IntValue(0)));
+      Parameters.Add(random = new ValueParameter<IRandom>("Random", new MersenneTwister()));
+
+      breedingStat = new List<Tuple<double, double, double>>();
+      hillclimbingStat = new List<Tuple<double, double>>();
+      tabuwalkingStat = new List<Tuple<double, double>>();
+    }
+
+    public abstract TSolutionContext CreateSingleSolutionContext(ISingleObjectiveSolutionScope<TSolution> solution);
+
+    #region IExecutionContext members
+    public IAtomicOperation CreateOperation(IOperator op) {
+      return new ExecutionContext(this, op, Scope);
+    }
+
+    public IAtomicOperation CreateOperation(IOperator op, IScope s) {
+      return new ExecutionContext(this, op, s);
+    }
+
+    public IAtomicOperation CreateChildOperation(IOperator op) {
+      return new ExecutionContext(this, op, Scope);
+    }
+
+    public IAtomicOperation CreateChildOperation(IOperator op, IScope s) {
+      return new ExecutionContext(this, op, s);
+    }
+    #endregion
+
+    IEnumerable<ISolutionScope<TSolution>> IPopulationContext<TSolution>.Population {
+      get { return Population; }
+    }
+  }
+
+  [Item("SingleSolutionMemPRContext", "Abstract base class for single solution MemPR contexts.")]
+  [StorableClass]
+  public abstract class SingleSolutionMemPRContext<TSolution, TContext, TSolutionContext> : ParameterizedNamedItem,
+      ISingleObjectiveSolutionContext<TSolution>, IEvaluatedSolutionsContext,
+      IIterationsManipulationContext, IStochasticContext, IMaximizationContext
+      where TSolution : class, IItem
+      where TContext : MemPRContext<TSolution, TContext, TSolutionContext>
+      where TSolutionContext : SingleSolutionMemPRContext<TSolution, TContext, TSolutionContext> {
+
+    private TContext parent;
+    public IExecutionContext Parent {
+      get { return parent; }
+      set { throw new InvalidOperationException("Cannot set the parent of a single-solution context."); }
+    }
+
+    [Storable]
+    private ISingleObjectiveSolutionScope<TSolution> scope;
+    public IScope Scope {
+      get { return scope; }
+    }
+
+    IKeyedItemCollection<string, IParameter> IExecutionContext.Parameters {
+      get { return Parameters; }
+    }
+    
+    public bool Maximization {
+      get { return parent.Maximization; }
+    }
+
+    public IRandom Random {
+      get { return parent.Random; }
+    }
+
+    [Storable]
+    private IValueParameter<IntValue> evaluatedSolutions;
+    public int EvaluatedSolutions {
+      get { return evaluatedSolutions.Value.Value; }
+      set { evaluatedSolutions.Value.Value = value; }
+    }
+
+    [Storable]
+    private IValueParameter<IntValue> iterations;
+    public int Iterations {
+      get { return iterations.Value.Value; }
+      set { iterations.Value.Value = value; }
+    }
+
+    IScope ISolutionContext.Solution {
+      get { return scope; }
+    }
+
+    ISolutionScope<TSolution> ISolutionContext<TSolution>.Solution {
+      get { return scope; }
+    }
+
+    ISingleObjectiveSolutionScope<TSolution> ISingleObjectiveSolutionContext<TSolution>.Solution {
+      get { return scope; }
+    }
+
+    [StorableConstructor]
+    protected SingleSolutionMemPRContext(bool deserializing) : base(deserializing) { }
+    protected SingleSolutionMemPRContext(SingleSolutionMemPRContext<TSolution, TContext, TSolutionContext> original, Cloner cloner)
+      : base(original, cloner) {
+      scope = cloner.Clone(original.scope);
+      evaluatedSolutions = cloner.Clone(original.evaluatedSolutions);
+      iterations = cloner.Clone(original.iterations);
+    }
+    public SingleSolutionMemPRContext(TContext baseContext, ISingleObjectiveSolutionScope<TSolution> solution) {
+      parent = baseContext;
+      scope = solution;
+      
+      Parameters.Add(evaluatedSolutions = new ValueParameter<IntValue>("EvaluatedSolutions", new IntValue(0)));
+      Parameters.Add(iterations = new ValueParameter<IntValue>("Iterations", new IntValue(0)));
+    }
+
+    #region IExecutionContext members
+    public IAtomicOperation CreateOperation(IOperator op) {
+      return new ExecutionContext(this, op, Scope);
+    }
+
+    public IAtomicOperation CreateOperation(IOperator op, IScope s) {
+      return new ExecutionContext(this, op, s);
+    }
+
+    public IAtomicOperation CreateChildOperation(IOperator op) {
+      return new ExecutionContext(this, op, Scope);
+    }
+
+    public IAtomicOperation CreateChildOperation(IOperator op, IScope s) {
+      return new ExecutionContext(this, op, s);
+    }
+    #endregion
+  }
+}
Index: branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Optimization/Interfaces.cs
===================================================================
--- branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Optimization/Interfaces.cs	(revision 14420)
+++ branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Optimization/Interfaces.cs	(revision 14420)
@@ -0,0 +1,191 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Algorithms.MemPR.Binary;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.BinaryVectorEncoding;
+
+/*************************************************
+ * ********************************************* *
+ *                    DATA                       *
+ * ********************************************* *
+ *************************************************/
+
+namespace HeuristicLab.Optimization.SolutionModel {
+
+  public interface ISolutionModel<TSolution> : IItem {
+    TSolution Sample();
+  }
+}
+
+namespace HeuristicLab.Optimization {
+
+  public interface ISolutionSubspace : IItem { }
+}
+
+/*************************************************
+   * ********************************************* *
+   *                  OPERATORS                    *
+   * ********************************************* *
+   *************************************************/
+
+namespace HeuristicLab.Optimization.SolutionModel {
+
+  public interface ISolutionModelTrainer<TSolution> : IOperator
+      where TSolution : class, IItem {
+    IScopeTreeLookupParameter<TSolution> SolutionParameter { get; }
+    ILookupParameter<ISolutionModel<TSolution>> SamplingModelParameter { get; }
+  }
+
+  public interface ISolutionModelTrainer<TSolution, TContext> : ISolutionModelTrainer<TSolution>
+      where TSolution : class, IItem
+      where TContext : ISolutionModelContext<TSolution> {
+
+    void TrainModel(TContext context);
+  }
+
+  public interface IBinarySolutionModelTrainer<TContext> : ISolutionModelTrainer<BinaryVector, TContext>
+      where TContext : ISolutionModelContext<BinaryVector> { }
+}
+
+namespace HeuristicLab.Optimization.LocalSearch {
+
+  public interface ILocalSearch<TSolution> : IOperator
+      where TSolution : class, IItem {
+    ILookupParameter<TSolution> SolutionParameter { get; }
+
+    Func<TSolution, double> EvaluateFunc { get; set; }
+  }
+
+  public interface ILocalSearch<TSolution, TContext> : ILocalSearch<TSolution>
+      where TSolution : class, IItem {
+
+    void Optimize(TContext context);
+  }
+
+  public interface IBinaryLocalSearch<TContext> : ILocalSearch<BinaryVector, TContext> {
+    
+  }
+
+}
+
+/*************************************************
+   * ********************************************* *
+   *                  CONTEXTS                     *
+   * ********************************************* *
+   *************************************************/
+
+namespace HeuristicLab.Optimization {
+  
+  public interface IStochasticContext : IExecutionContext {
+    IRandom Random { get; }
+  }
+
+  public interface IMaximizationContext : IExecutionContext {
+    bool Maximization { get; }
+  }
+
+  public interface IEvaluatedSolutionsContext : IExecutionContext {
+    int EvaluatedSolutions { get; set; }
+  }
+
+  public interface IIterationsContext : IExecutionContext {
+    int Iterations { get; }
+  }
+
+  public interface IIterationsManipulationContext : IIterationsContext {
+    new int Iterations { get; set; }
+  }
+
+  public interface IPopulationContext : IExecutionContext {
+    IEnumerable<IScope> Population { get; }
+  }
+
+  public interface IPopulationContext<TSolution> : IPopulationContext {
+    new IEnumerable<ISolutionScope<TSolution>> Population { get; }
+  }
+
+  public interface ISingleObjectivePopulationContext<TSolution> : IPopulationContext<TSolution> {
+    new IEnumerable<ISingleObjectiveSolutionScope<TSolution>> Population { get; }
+  }
+
+  public interface ISolutionContext : IExecutionContext {
+    IScope Solution { get; }
+  }
+
+  public interface ISolutionContext<TSolution> : ISolutionContext {
+    new ISolutionScope<TSolution> Solution { get; }
+  }
+
+  public interface ISingleObjectiveSolutionContext<TSolution> : ISolutionContext<TSolution> {
+    new ISingleObjectiveSolutionScope<TSolution> Solution { get; }
+  }
+
+  /* Probably a setter is not needed anyway, since there is Adopt() also
+  public interface ISolutionManipulationContext : ISolutionContext {
+    new IScope Solution { get; set; }
+  }
+
+  public interface ISolutionManipulationContext<TSolution> : ISolutionManipulationContext, ISolutionContext<TSolution> {
+    new ISolutionScope<TSolution> Solution { get; set; }
+  }
+
+  public interface ISingleObjectiveSolutionManipulationContext<TSolution> : ISolutionManipulationContext<TSolution>, ISingleObjectiveSolutionContext<TSolution> {
+    new ISingleObjectiveSolutionScope<TSolution> Solution { get; set; }
+  }
+  */
+
+  public interface ISolutionSubspaceContext : IExecutionContext {
+    ISolutionSubspace Subspace { get; }
+  }
+  public interface IBinarySolutionSubspaceContext : ISolutionSubspaceContext {
+    new BinarySolutionSubspace Subspace { get; }
+  }
+}
+
+namespace HeuristicLab.Optimization.SolutionModel {
+  public interface ISolutionModelContext<TSolution> : IExecutionContext {
+    ISolutionModel<TSolution> Model { get; set; }
+  }
+}
+
+
+/*************************************************
+   * ********************************************* *
+   *                   SCOPES                      *
+   * ********************************************* *
+   *************************************************/
+  
+namespace HeuristicLab.Core {
+  public interface ISolutionScope<TSolution> : IScope {
+    TSolution Solution { get; set; }
+
+    void Adopt(ISolutionScope<TSolution> orphan);
+  }
+
+  public interface ISingleObjectiveSolutionScope<TSolution> : ISolutionScope<TSolution> {
+    double Fitness { get; set; }
+
+    void Adopt(ISingleObjectiveSolutionScope<TSolution> orphan);
+  }
+}
Index: branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Plugin.cs
===================================================================
--- branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Plugin.cs	(revision 14420)
+++ branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Plugin.cs	(revision 14420)
@@ -0,0 +1,43 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Algorithms.MemPR {
+
+  [Plugin("HeuristicLab.Algorithms.MemPR", "Provides the MemPR (MEMetic Path Relinking) algorithm.", "3.3.14.0")]
+  [PluginFile("HeuristicLab.Algorithms.MemPR-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Analysis", "3.3")]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.BinaryVectorEncoding", "3.3")]
+  [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3")]
+  [PluginDependency("HeuristicLab.Random", "3.3")]
+  public class HeuristicLabAlgorithmsMemPRPlugin : PluginBase {
+  }
+}
+
Index: branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Properties/AssemblyInfo.cs
===================================================================
--- branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Properties/AssemblyInfo.cs	(revision 14420)
+++ branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Properties/AssemblyInfo.cs	(revision 14420)
@@ -0,0 +1,36 @@
+﻿using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Algorithms.MemPR")]
+[assembly: AssemblyDescription("Plugin that provides the MemPR (memetic path relinking) algorithm.")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2016 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("9d274421-6332-4fbc-aae4-467ace27c368")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("3.3.0.0")]
+[assembly: AssemblyFileVersion("3.3.14.0")]
Index: branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/SingleObjectiveSolutionScope.cs
===================================================================
--- branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/SingleObjectiveSolutionScope.cs	(revision 14420)
+++ branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/SingleObjectiveSolutionScope.cs	(revision 14420)
@@ -0,0 +1,147 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+using HeuristicLab.Collections;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.MemPR {
+  [Item("MemPRScope", "Scope for a MemPR individual.")]
+  [StorableClass]
+  public sealed class SingleObjectiveSolutionScope<T> : NamedItem, ISingleObjectiveSolutionScope<T> where T : class, IItem {
+    public new static Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.OrgChart; }
+    }
+
+    [Storable]
+    private IScope parent;
+    public IScope Parent {
+      get { return parent; }
+      set {
+        if (parent != value) {
+          parent = value;
+        }
+      }
+    }
+
+    [Storable]
+    private VariableCollection variables;
+    public VariableCollection Variables {
+      get { return variables; }
+    }
+
+    [Storable]
+    private ScopeList subScopes;
+    public ScopeList SubScopes {
+      get { return subScopes; }
+    }
+
+    [Storable]
+    private Variable solution;
+    public T Solution {
+      get { return (T)solution.Value; }
+      set { solution.Value = value; }
+    }
+
+    [Storable]
+    private Variable fitness;
+    public double Fitness {
+      get { return ((DoubleValue)fitness.Value).Value; }
+      set { ((DoubleValue)fitness.Value).Value = value; }
+    }
+
+    [StorableConstructor]
+    private SingleObjectiveSolutionScope(bool deserializing) : base(deserializing) { }
+    private SingleObjectiveSolutionScope(SingleObjectiveSolutionScope<T> original, Cloner cloner)
+      : base(original, cloner) {
+      // the parent will not be deep-cloned
+      parent = original.parent;
+      variables = cloner.Clone(original.variables);
+      subScopes = cloner.Clone(original.subScopes);
+      foreach (var child in SubScopes)
+        child.Parent = this;
+      solution = cloner.Clone(original.solution);
+      fitness = cloner.Clone(original.fitness);
+
+      RegisterSubScopesEvents();
+    }
+    public SingleObjectiveSolutionScope(T code, string codeName, double fitness, string fitnessName) {
+      this.solution = new Variable(codeName, code);
+      this.fitness = new Variable(fitnessName, new DoubleValue(fitness));
+      variables = new VariableCollection(2) { this.solution, this.fitness };
+      subScopes = new ScopeList(2);
+
+      RegisterSubScopesEvents();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SingleObjectiveSolutionScope<T>(this, cloner);
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      RegisterSubScopesEvents();
+    }
+
+    public void Clear() {
+      variables.Clear();
+      subScopes.Clear();
+    }
+
+    #region SubScopes Events
+    private void RegisterSubScopesEvents() {
+      if (subScopes != null) {
+        subScopes.ItemsAdded += SubScopes_ItemsAdded;
+        subScopes.ItemsRemoved += SubScopes_ItemsRemoved;
+        subScopes.ItemsReplaced += SubScopes_ItemsReplaced;
+        subScopes.CollectionReset += SubScopes_CollectionReset;
+      }
+    }
+    private void SubScopes_ItemsAdded(object sender, CollectionItemsChangedEventArgs<IndexedItem<IScope>> e) {
+      foreach (var item in e.Items) item.Value.Parent = this;
+    }
+    private void SubScopes_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<IScope>> e) {
+      foreach (var item in e.Items) item.Value.Parent = null;
+    }
+    private void SubScopes_ItemsReplaced(object sender, CollectionItemsChangedEventArgs<IndexedItem<IScope>> e) {
+      foreach (var oldItem in e.OldItems) oldItem.Value.Parent = null;
+      foreach (var item in e.Items) item.Value.Parent = this;
+    }
+    private void SubScopes_CollectionReset(object sender, CollectionItemsChangedEventArgs<IndexedItem<IScope>> e) {
+      foreach (var oldItem in e.OldItems) oldItem.Value.Parent = null;
+      foreach (var item in e.Items) item.Value.Parent = this;
+    }
+    #endregion
+
+    public void Adopt(ISingleObjectiveSolutionScope<T> orphan) {
+      Solution = orphan.Solution;
+      Fitness = orphan.Fitness;
+    }
+
+    public void Adopt(ISolutionScope<T> orphan) {
+      Solution = orphan.Solution;
+      Fitness = double.NaN;
+    }
+  }
+}
